program biaslist

! BIAS$B%G!<%?$N%j%9%H$H!"$=$l0J30$N%G!<%?$N%j%9%H$r:n$k(B
  
  character (len=80) :: line, fname, pname, bname, chgrtfn, blist, nblist, bslist 
  character (len=20) :: object, toupper, fext*5
  
  iarg=iargc()          ! $B%3%^%s%I%i%$%s0z?t$N?t(B($B%W%m%0%i%`L>$r=|$/(B)
  call getarg(0,pname)  ! $B<B9T$7$?%W%m%0%i%`L>$rF@$k(B
  len=len_trim(pname)   ! $B%W%m%0%i%`L>$NJ8;z?t$rF@$k(B
  if ( iarg<1 ) then    ! $B%3%^%s%I%i%$%s$K0z?t$,$J$1$l$P(B...
     print *, 'usage: ', pname(:len), ' list1 list2 list3 extension'  ! $B;HMQK!(B
     print *, '         list1: list of bias files '
     print *, '         list2: list of files except for bias'
     print *, '         list1: list of bias-subtracted files'
     print *, '         extension : filename extension for FITS'
     stop
  end if
  call getarg(1,blist)  ! $B%3%^%s%I%i%$%s$N0z?t$rF@$k(B
  
  fext='fits'
  if ( iarg>=2 ) call getarg(2,nblist)
  if ( iarg>=3 ) call getarg(3,bslist)
  if ( iarg==4 ) call getarg(4,fext)
  
  call system('ls *.'//fext//' > tmp_rfh')

  open(11,file='tmp_rfh')
  open(21,file=blist)
  open(22,file=nblist)
  open(23,file=bslist)

  do i=1, 999
     read(11,*,end=999) fname
     if ( index(fname,'_bs')==0 ) then
        open(12, file=fname, access='direct', recl=80, form='formatted')
        j=0
        line=' '
        object = ' '
        do while (line(1:3)/='END' )  ! $BFI9~$s$@J8;zNs$N:G=i$,(B'END'$B$G$J$$8B$j(B
           j=j+1
           read(12, '(a80)',rec=j) line ! 80$BJ8;z$NFI9~(B
           if ( line(1:8)=='OBJECT  ' ) then
              object=toupper(line(12:15))
           else if ( line(1:8)=='EXPTIME ' ) then
              read(line(10:31),*) exptime
           end if
        end do
        if (object(1:4)=='BIAS' .and. exptime==0. ) then
           print *, ' bias    -> ',fname(:50)
           write (21,'(a70)') fname(:70)
        else
           print *, ' notbias -> ', fname(:50)
           write (22,'(a70)') fname(:70)
           bname=chgrtfn(fname, '', 'bs')
           write (23,'(a70)') bname(:70)
        end if
        close(12)
     end if
  end do
  close(11)
  close(21)
  close(22)
  close(23)

999 continue

end program biaslist


