#       isophotes.cl
#
#	Update: M.Hamabe 1994-08-17
#	Update: M.Hamabe 1995-06-30
#
procedure  isophotes (images)

file	images	{prompt='input images'}

file	cntpar		{'cntpar',prompt='table of contour levels'}
bool	magscale	{yes,prompt='contour levels are mag-scale? no=linear'}
bool	interactive	{yes,prompt='set contour levels interactively?'}
bool	show		{yes,prompt='display on terminal?'}
char    device		{'xserv',prompt='plotting device (tek/xwin/xserv/inq)'}
bool	hardcopy	{no,prompt='make a hardcopy?'}
#char	hdev		{'ps',prompt='hardcopy device (ps/lips)'}
char	hfile		{'isophotes.ps',prompt='hardcopy-file name'}
bool	id		{yes,prompt='plot ID on the hardcopy?'}
bool	ticks		{yes,prompt='plot tick marks on the border?'}
char	editor		{'vi',prompt='editor used in editing cntpar'}
char	title		{'',prompt='optional title for plot'}

struct  *ilist

begin
	file	image
	file	temp1

	temp1 = mktemp ("isophotes.tmp")
	files (images, > temp1)
	ilist = temp1

	task $isophotes1=("$" // osfn("spiral$bin/") // "isophotes.e $(*)" )
	while (fscan (ilist, image) !=EOF) {
	   #isophotes1 (image,cntpar,magscale,interactive,show,device,hardcopy,hdev,hfile,id,ticks,editor,title)
	   isophotes1 (image,cntpar,magscale,interactive,show,device,hardcopy,hfile,id,ticks,editor,title)
	}

	ilist = ""
	del ("isophotes.tmp*", verify-, >& "dev$null")
end
